
package net.minecraft.src;

import java.util.HashMap;

import net.minecraft.src.buildcraft.core.IInventoryRender;
import net.minecraft.src.forge.MinecraftForgeClient;
import net.minecraft.src.pe.PowerExtended;
import net.minecraft.src.pe.RenderTurbine;

public class mod_PE extends BaseModMp
{
    public static mod_PE                                       instance;

    public static HashMap<EntityRenderIndex, IInventoryRender> renderByERI   = new HashMap<EntityRenderIndex, IInventoryRender>();
    public static String                                       texbaseBc     = "/net/minecraft/src/pe/gfx/base_bcend.png";
    public static String                                       texbaseIc     = "/net/minecraft/src/pe/gfx/base_icend.png";
    public static String                                       textrunkblue  = "/net/minecraft/src/pe/gfx/trunk_blue.png";

    public static String                                       textrunkbrown = "/net/minecraft/src/pe/gfx/trunk_internal.png";

    public static String                                       textrunkred   = "/net/minecraft/src/pe/gfx/trunk_crystal.png";

    String[]                                                   preload       = { /*
                                                                                  * texbaseBc,
                                                                                  * texbaseIc,
                                                                                  * textrunkblue,
                                                                                  * textrunkbrown,
                                                                                  * textrunkred
                                                                                  */};

    public mod_PE()
    {
        // Make a copy of this classes instance
        mod_PE.instance = this;
    }

    @Override
    public void ModsLoaded()
    {
        PowerExtended.initialize();
        PowerExtended.initializeModels();

        // Invetory Rendering
        renderByERI.put(new EntityRenderIndex(PowerExtended.blockTurbine, 0), new RenderTurbine(0));
        renderByERI.put(new EntityRenderIndex(PowerExtended.blockTurbine, 1), new RenderTurbine(1));
        // preload textures
        for(String element : this.preload)
        {
            MinecraftForgeClient.preloadTexture(element);
        }
    }

    @Override
    public void RenderInvBlock(RenderBlocks renderblocks, Block block, int i, int j)
    {
        if(block.getRenderType() == PowerExtended.renderTypeByERI)
        {
            EntityRenderIndex eri = new EntityRenderIndex(block, i);
            if(renderByERI.containsKey(eri))
            {
                IInventoryRender r = renderByERI.get(eri);
                r.inventoryRender(-0.5D, -0.5D, -0.5D, 0.0f, 0.0f);
            }
        }
    }

    @Override
    public String Version()
    {
        return "zero.one.alpha";
    }

    public static class EntityRenderIndex
    {
        Block block;
        int   damage;

        public EntityRenderIndex(Block block, int damage)
        {
            this.block = block;
            this.damage = damage;
        }

        @Override
        public boolean equals(Object o)
        {
            if(!(o instanceof EntityRenderIndex))
            {
                return false;
            }

            EntityRenderIndex i = (EntityRenderIndex) o;

            return (i.block == this.block) && (i.damage == this.damage);
        }

        @Override
        public int hashCode()
        {
            return this.block.hashCode() + this.damage;
        }
    }

}
