
package net.minecraft.src.pe;

import java.util.Random;

import net.minecraft.src.BlockContainer;
import net.minecraft.src.EntityPlayer;
import net.minecraft.src.Material;
import net.minecraft.src.ModLoader;
import net.minecraft.src.TileEntity;
import net.minecraft.src.World;

public class BlockTurbine extends BlockContainer
{

    public BlockTurbine(int i)
    {
        super(i, 0, Material.rock);
        this.setHardness(1.0F);
        this.setRequiresSelfNotify();
    }

    @Override
    public boolean blockActivated(World world, int i, int j, int k, EntityPlayer entityplayer)
    {
        TileEntity tile = world.getBlockTileEntity(i, j, k);
        ModLoader.getMinecraftInstance().displayGuiScreen(new GuiTurbine(entityplayer.inventory, (TileTurbine) tile));
        return true;
    }

    @Override
    public TileEntity getBlockEntity()
    {
        return new TileTurbine();
    }

    @Override
    public int getRenderType()
    {
        return PowerExtended.renderTypeByERI;
    }

    @Override
    public int idDropped(int i, Random random)
    {
        return PowerExtended.blockMachine.blockID;
    }

    @Override
    public boolean isOpaqueCube()
    {
        return false;
    }

    @Override
    public void onBlockClicked(World world, int i, int j, int k, EntityPlayer entityplayer)
    {
    }

    @Override
    public int quantityDropped(int i, Random random)
    {
        return 1;
    }

    @Override
    public boolean renderAsNormalBlock()
    {
        return false;
    }

    @Override
    protected int damageDropped(int i)
    {
        return i;
    }
}
