
package net.minecraft.src.pe;

import net.minecraft.src.GuiContainer;
import net.minecraft.src.InventoryPlayer;
import net.minecraft.src.Tessellator;

import org.lwjgl.opengl.GL11;
import org.lwjgl.util.vector.Vector2f;

public class GuiTurbine extends GuiContainer
{
    float       lastPower;
    float       power;
    TileTurbine tilet;

    public GuiTurbine(InventoryPlayer invplayer, TileTurbine tturbine)
    {
        super(new ContainerTurbine(invplayer, tturbine));

        this.power = 1f;
        this.tilet = tturbine;
    }

    protected void drawArrow(int i, int j, float theta)
    {
        int k = 176;
        int l = 0;
        float f = 0.00390625F;
        float f1 = 0.00390625F;

        int w = 16, h = 16;

        // Points
        Vector2f[] pts = new Vector2f[4];

        pts[0] = new Vector2f(0, h);
        pts[1] = new Vector2f(w, h);
        pts[2] = new Vector2f(w, 0);
        pts[3] = new Vector2f(0, 0);

        // apply transformation
        for(int q = 0; q < 4; q++)
        {
            pts[q] = PEUtil.translate(pts[q], -8, -16);
            pts[q] = PEUtil.rotate(pts[q], theta);
            pts[q] = PEUtil.translate(pts[q], 8 + i, 16 + j);
        }

        Tessellator tessellator = Tessellator.instance;
        tessellator.startDrawingQuads();
        tessellator.addVertexWithUV(pts[0].x, pts[0].y, this.zLevel, (k + 0) * f, (l + h) * f1);
        tessellator.addVertexWithUV(pts[1].x, pts[1].y, this.zLevel, (k + w) * f, (l + h) * f1);
        tessellator.addVertexWithUV(pts[2].x, pts[2].y, this.zLevel, (k + w) * f, (l + 0) * f1);
        tessellator.addVertexWithUV(pts[3].x, pts[3].y, this.zLevel, (k + 0) * f, (l + 0) * f1);
        tessellator.draw();
    }

    @Override
    protected void drawGuiContainerBackgroundLayer(float f)
    {
        Turbine t = this.tilet.tp.getTurbine();
        if(t == null)
        {
            return;
        }

        float powerNew = this.tilet.tp.lastPower / (float) t.getMaxOutputRateEUt();
        this.power = (powerNew + this.lastPower) / 2;

        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        int i = this.mc.renderEngine.getTexture("/net/minecraft/src/pe/gfx/turbine_gui.png");
        this.mc.renderEngine.bindTexture(i);

        int j = (this.width - this.xSize) / 2;
        int k = (this.height - this.ySize) / 2;

        // Draw Pointer Background
        this.drawTexturedModalRect(j + 68, k + 19, 176, 16, 40, 18);

        // Draw Pointer
        float p = (float) Math.PI;
        float d = 0.05f;
        float startAngle = -(p / 2);
        float powerAngle = startAngle + (d * p) + (this.power * p * 0.9f);
        this.drawArrow(j + 80, k + 20, powerAngle);

        // Draw Gui Background
        this.drawTexturedModalRect(j, k, 0, 0, this.xSize, this.ySize);

        this.lastPower = this.power;
    }

    @Override
    protected void drawGuiContainerForegroundLayer()
    {
        Turbine t = this.tilet.tp.getTurbine();
        if(t == null)
        {
            return;
        }

        switch(t.tier)
        {
            case 1:
                this.fontRenderer.drawString(BlockNames.turbine1Name, 60, 6, 0x404040);
                break;
            default:
                this.fontRenderer.drawString(BlockNames.turbine0Name, 60, 6, 0x404040);
                break;
        }

        int max = t.getMaxOutputRateEUt();
        this.fontRenderer.drawString(String.valueOf(0), 58, 32, 0x404040);
        this.fontRenderer.drawString(String.valueOf(this.tilet.tp.lastPower).concat(" EU/t"), 16, 18, 0x404040);
        this.fontRenderer.drawString(String.valueOf(max).concat(" EU/t"), 113, 32, 0x404040);
        this.fontRenderer.drawString("Inventory", 8, (this.ySize - 96) + 2, 0x404040);
    }
}
